## ros-noetic-sick-scan 1.10.1

=== CMakeLists.txt ===
####################################################
# CMakeLists.txt for project sick_scan
#
#
####################################################
cmake_minimum_required(VERSION 2.8.3)

# build options: set OFF for relese version, ON for development and test
option(ENABLE_EMULATOR "Build emulator for offline and unittests" OFF) # OFF (release) or ON (development)
option(BUILD_DEBUG_TARGET "Build debug target" OFF) # OFF (release) or ON (development)

# set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
# set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpedantic")
#

# Added CMP0048 to avoid unstable warning of build process
#
if (POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)

project(sick_scan)



macro(use_cxx11)
    if (CMAKE_VERSION VERSION_LESS "3.1")
        if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
        endif ()
    else ()
        set(CMAKE_CXX_STANDARD 11)
    endif ()
endmacro(use_cxx11)

if(BUILD_DEBUG_TARGET)
        set(CMAKE_BUILD_TYPE Debug) #uncomment to activate debug mode for lib_sick as well
        set(CMAKE_ENABLE_EXPORTS 1) #uncomment to activate debug mode for lib_sick as well
        # https://cmake.org/cmake/help/v3.5/prop_tgt/ENABLE_EXPORTS.html
        # set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++03")
endif(BUILD_DEBUG_TARGET)

# Switch on, if you use c11-specific commands
use_cxx11()
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-format-overflow")

# By uncommenting the following lines you can list all variable names ...
# --- CUT ---
# get_cmake_property(_variableNames VARIABLES)
# list (SORT _variableNames)
# foreach (_variableName ${_variableNames})
#	message(STATUS "${_variableName}=${${_variableName}}")
# endforeach()
# --- CUT ---

# For warning <catkin_workspace>/devel/include' should be placed in
# the devel space instead of the build space
# see: https://answers.ros.org/question/67244/qtcreator-with-catkin/


# message(${CMAKE_BINARY_DIR})

# set(CATKIN_DEVEL_PREFIX "${CMAKE_BINARY_DIR}/devel")
# set(CMAKE_PREFIX_PATH "${CMAKE_BINARY_DIR}/devel;/opt/ros/melodic")

find_package(Boost REQUIRED COMPONENTS system serialization)

if(ENABLE_EMULATOR)
        find_package(jsoncpp REQUIRED) # install libjsoncpp by running "sudo apt-get install libjsoncpp-dev"
endif(ENABLE_EMULATOR)

find_package(catkin REQUIRED COMPONENTS
        roscpp
        roslib # needed ros::package::getPath()
        sensor_msgs
        diagnostic_updater
        dynamic_reconfigure
        geometry_msgs
        std_msgs
        sensor_msgs
        visualization_msgs
        message_generation
        tf
        tf2
        )


find_package(PkgConfig REQUIRED)



generate_dynamic_reconfigure_options(
        cfg/SickScan.cfg
        cfg/tf_dyn.cfg
)

# driver messages
add_message_files(
        DIRECTORY msg
        FILES
        SickImu.msg
        RadarObject.msg
        RadarPreHeaderDeviceBlock.msg
        RadarPreHeaderMeasurementParam1Block.msg
        RadarPreHeaderStatusBlock.msg
        RadarPreHeaderEncoderBlock.msg
        RadarPreHeader.msg
        RadarScan.msg
        Encoder.msg
        LFErecFieldMsg.msg
        LFErecMsg.msg
        LIDoutputstateMsg.msg
)

# driver services
add_service_files(
        DIRECTORY srv
        FILES
        ColaMsgSrv.srv
        ECRChangeArrSrv.srv
        LIDoutputstateSrv.srv
)

if(ENABLE_EMULATOR)
    # emulator messages
    add_message_files(
        DIRECTORY test/emulator/msg
        FILES
        SickLocColaTelegramMsg.msg
        SickLocDiagnosticMsg.msg
        SickLocResultPortCrcMsg.msg
        SickLocResultPortHeaderMsg.msg
        SickLocResultPortPayloadMsg.msg
        SickLocResultPortTelegramMsg.msg
        SickLocResultPortTestcaseMsg.msg
    )

    # emulator services
    add_service_files(
        DIRECTORY test/emulator/srv
        FILES
        SickLocColaTelegramSrv.srv
        SickLocRequestTimestampSrv.srv
        SickLocSetResultModeSrv.srv
        SickLocSetResultPoseIntervalSrv.srv
        SickLocIsSystemReadySrv.srv
        SickLocSetPoseSrv.srv
        SickLocSetResultPortSrv.srv
        SickLocStartLocalizingSrv.srv
        SickLocStopSrv.srv
        SickLocRequestResultDataSrv.srv
        SickLocSetResultEndiannessSrv.srv
        SickLocSetResultPoseEnabledSrv.srv
        SickLocStateSrv.srv
        SickLocTimeSyncSrv.srv
        SickDevGetLidarConfigSrv.srv
        SickDevGetLidarIdentSrv.srv
        SickDevGetLidarStateSrv.srv
        SickDevSetLidarConfigSrv.srv
        SickGetSoftwareVersionSrv.srv
        SickLocAutoStartActiveSrv.srv
        SickLocAutoStartSavePoseIntervalSrv.srv
        SickLocAutoStartSavePoseSrv.srv
        SickLocForceUpdateSrv.srv
        SickLocInitializePoseSrv.srv
        SickLocInitialPoseSrv.srv
        SickLocMapSrv.srv
        SickLocMapStateSrv.srv
        SickLocOdometryActiveSrv.srv
        SickLocOdometryPortSrv.srv
        SickLocOdometryRestrictYMotionSrv.srv
        SickLocReflectorsForSupportActiveSrv.srv
        SickLocResultEndiannessSrv.srv
        SickLocResultModeSrv.srv
        SickLocResultPortSrv.srv
        SickLocResultPoseIntervalSrv.srv
        SickLocResultStateSrv.srv
        SickLocRingBufferRecordingActiveSrv.srv
        SickLocSaveRingBufferRecordingSrv.srv
        SickLocSetAutoStartActiveSrv.srv
        SickLocSetAutoStartSavePoseIntervalSrv.srv
        SickLocSetMapSrv.srv
        SickLocSetOdometryActiveSrv.srv
        SickLocSetOdometryPortSrv.srv
        SickLocSetOdometryRestrictYMotionSrv.srv
        SickLocSetReflectorsForSupportActiveSrv.srv
        SickLocSetRingBufferRecordingActiveSrv.srv
        SickLocStartDemoMappingSrv.srv
        SickReportUserMessageSrv.srv
        SickSavePermanentSrv.srv
        SickDevSetIMUActiveSrv.srv
        SickDevIMUActiveSrv.srv
    ) 
endif(ENABLE_EMULATOR)

generate_messages(
        DEPENDENCIES
        std_msgs
        geometry_msgs
        sensor_msgs
)

catkin_package(
        CATKIN_DEPENDS message_runtime roscpp sensor_msgs diagnostic_updater dynamic_reconfigure pcl_conversions pcl_ros tf tf2
        LIBRARIES sick_scan_lib
        INCLUDE_DIRS include
        DEPENDS Boost
)

include_directories(include include/tinyxml ${catkin_INCLUDE_DIRS}  include/sick_scan)

add_library(sick_scan_lib
        driver/src/dataDumper.cpp
        driver/src/sick_scan_common.cpp
        driver/src/abstract_parser.cpp
        driver/src/tcp/tcp.cpp
        driver/src/tcp/Mutex.cpp
        driver/src/tcp/SickThread.cpp
        driver/src/tcp/errorhandler.cpp
        driver/src/tcp/toolbox.cpp
        driver/src/tcp/Time.cpp
        driver/src/tcp/colaa.cpp
        driver/src/tcp/colab.cpp
        driver/src/binScanf.cpp
        driver/src/sick_scan_common_tcp.cpp
        driver/src/sick_generic_radar.cpp
        driver/src/sick_generic_imu.cpp
        driver/src/sick_generic_parser.cpp
        driver/src/sick_scan_common_nw.cpp
        include/sick_scan/sick_scan_config_internal.h
        driver/src/sick_scan_config_internal.cpp
        include/sick_scan/softwarePLL.h
        driver/src/softwarePLL.cpp
        driver/src/helper/angle_compensator.cpp
        driver/src/sick_generic_field_mon.cpp
        driver/src/sick_scan_marker.cpp
        driver/src/sick_scan_messages.cpp
        driver/src/sick_scan_services.cpp
        )

add_dependencies(sick_scan_lib ${PROJECT_NAME}_gencfg ${catkin_EXPORTED_TARGETS} ${${PROJECT_NAME}_EXPORTED_TARGETS})

target_link_libraries(sick_scan_lib
        ${catkin_LIBRARIES})

add_executable(sick_generic_caller
        driver/src/sick_generic_laser.cpp
        driver/src/sick_generic_caller.cpp
        )

#
#  radar_object_marker (receives radar msg. and publishes marker array for rviz or similar
#
add_executable(radar_object_marker
        tools/radar_object_marker/src/radar_object_marker.cpp
        tools/pcl_converter/src/gnuplotPaletteReader.cpp
        include/radar_object_marker/radar_object_marker.h)

target_link_libraries(radar_object_marker sick_scan_lib ${catkin_LIBRARIES} ${Boost_LIBRARIES})
#
#
#


#
# pcl_converter disabled to avoid dependency to pcl
#
# add_executable(pcl_converter tools/pcl_converter/src/pcl_converter.cpp tools/pcl_converter/src/gnuplotPaletteReader.cpp)
#
# target_link_libraries(pcl_converter
#        ${catkin_LIBRARIES})


target_link_libraries(sick_generic_caller sick_scan_lib)

add_executable(sick_scan_test
        test/src/sick_scan_test.cpp
        driver/src/tinyxml/tinystr.cpp
        driver/src/tinyxml/tinyxml.cpp
        driver/src/tinyxml/tinyxmlerror.cpp
        driver/src/tinyxml/tinyxmlparser.cpp
        )
target_link_libraries(sick_scan_test
        ${catkin_LIBRARIES}
        ${roslib_LIBRARIES}
        sick_scan_lib)

install(TARGETS sick_scan_lib
        DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(
        TARGETS
        sick_generic_caller
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(
        TARGETS
        sick_scan_test
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(FILES include/${PROJECT_NAME}/abstract_parser.h
        include/${PROJECT_NAME}/sick_scan_common.h
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY test/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/test
        FILES_MATCHING PATTERN "*.xml"
        PATTERN "test/src" EXCLUDE)

install(DIRECTORY launch/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

install(DIRECTORY meshes/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/meshes)

install(DIRECTORY urdf/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/urdf)

if(ENABLE_EMULATOR)
    #
    # emulator
    #
    # message("ENABLE_EMULATOR: build with emulator...")

    add_executable(sick_scan_emulator
        test/emulator/src/test_server.cpp
        test/emulator/src/test_server_thread.cpp
        test/emulator/src/client_socket.cpp
        test/emulator/src/cola_converter.cpp
        test/emulator/src/cola_encoder.cpp
        test/emulator/src/cola_parser.cpp
        test/emulator/src/cola_transmitter.cpp
        test/emulator/src/crc/crc16ccitt_false.cpp
        test/emulator/src/pcapng_json_parser.cpp
        test/emulator/src/random_generator.cpp
        test/emulator/src/result_port_parser.cpp
        test/emulator/src/ros_wrapper.cpp
        test/emulator/src/SoftwarePLL.cpp
        test/emulator/src/testcase_generator.cpp
        test/emulator/src/utils.cpp
        )

    target_link_libraries(sick_scan_emulator
        ${catkin_LIBRARIES}
        ${roslib_LIBRARIES}
        jsoncpp_lib # ${jsoncpp_LIBRARIES}
        sick_scan_lib)

    target_compile_definitions(sick_scan_emulator PUBLIC __ROS_VERSION=1)

    target_include_directories(sick_scan_emulator PUBLIC test/emulator/include)

    install(TARGETS sick_scan_emulator
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

    install(DIRECTORY test/emulator/launch/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch)

    install(DIRECTORY test/emulator/yaml/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/yaml)

    install(DIRECTORY test/emulator/scandata/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/scandata)

endif(ENABLE_EMULATOR)

=== debian/changelog ===
ros-noetic-sick-scan (1.10.1-1focal) focal; urgency=high

  * Update ipconfig.md
  * Update ipconfig.md
  * Update ipconfig.md
  * Contributors: Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 17 Mar 2021 23:00:00 -0000

ros-noetic-sick-scan (1.7.8-1focal) focal; urgency=high

  * fixes #100 <https://github.com/SICKAG/sick_scan/issues/100>
  * Update software_pll.md
  * software pll information added
  * Update angular_compensation.md
  * angle compensator
  * compensation example plot updated
  * angle compensation fixed for NAV2xx
  * sizt_t warning reduced, bugfix for result flag by changing ip address
  * network comp. to windows
  * pcl dependency modified
  * Contributors: Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 01 Sep 2020 22:00:00 -0000

ros-noetic-sick-scan (1.6.0-1focal) focal; urgency=high

  * NAV 210+NAV245 support added code reformated
  * NAV310 added
  * Contributors: Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 13 May 2020 22:00:00 -0000

ros-noetic-sick-scan (1.4.2-1focal) focal; urgency=high

  * fixed timing issues with MRS6124
  * added launch info for lms4xxx
  * added LMS 4xxx support
  * tim_7xxS dependencys included
  * Adding info for 7xxS-Launch-file
  * safety scanner added
  * added dependency for thrusty
  * added information about TIM 7xx launch
  * IMU Support, scan freq. and angle. resolution settings added
  * TiM7xx integrated
  * typical startup sequence
  * added lms1xx hires mode
  * added support for high ang. resolution for LMS 1xx
  * added pointcloud chopping
  * Issue resolve handling added
  * Pointcloud splitting prepared
  * added timing documentation
  * cartographer support improved
  * improved IMU support
  * Update google_cartographer.md
  * added Networktiming PLL
  * improved performance, start of tim7xx integration
  * Contributors: Michael Lehning

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 13 Nov 2019 23:00:00 -0000

ros-noetic-sick-scan (0.0.16-1focal) focal; urgency=high

  * Update README.md
  * Improved performance

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 13 Feb 2019 23:00:00 -0000

ros-noetic-sick-scan (0.0.15-1focal) focal; urgency=high

  * Update README.md
  * Support for Ubuntu Trusty #001 <https://github.com/SICKAG/sick_scan/issues/001>
  * ip v4 parsing changed due to support of older linux version
  * Contributors: Michael Lehning, Unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Mon, 04 Feb 2019 23:00:00 -0000

ros-noetic-sick-scan (0.0.14-1focal) focal; urgency=high

  * Merge branch 'devel'
  * ip address setting support, improved Debug MSG
  * Updated MRS6xxx launchfile
  * getting diagrams otimized for MRS6124
  * Warning option as comment added
  * compilation fixes for uninitialized variables and no return functions
  * writing ip address to eeprom prepared
  * improved imu support
  * added Python script to detect scanners
  * Added first implementation of imu support
  * IMU message handling prepared
  * added Ip arg name
  * Updated meshes
  * Sample file for launching and rviz-config files
  * Added lms1 and lms5 meshes and urdfs for them.  The gazebo sensors might still need work
  * Lookup Table for multi echo fixed
  * Test tool integrated into CMakeLists.txt
  * Build receipt for sensor_alighment
  * Fix for startup procedure to enable automatic  SOPAS ascii to SOPAS bin.
  * stopScanData introduced, init flag introduced, signal handler introduced
    change start process to state machine
  * radar_object_marker launch file updated
  * Radar Simulation optimized
  * Parsing of  PreHeader fixed and simulation optimized
    Raw target added for simulatoin
  * RMS3xx documentation
  * Preheading Parsing optimized
  * Radar preheader parsing extended
  * Radar datagram explanation
  * Only first echo for MRS6124 as default to reduct data volume
  * radar visualization optimized
  * marker optimized
  * clean of of radar_object_marker
  * support hector slam
  * SLAM-Support documentation
  * hector slam support
  * initial radar documentation added
  * cleanup test program
  * test launch file added to show pointcloud2 AND scans for the MRS1xxx
  * timestamp of radar msg. improved, pointcloud2 debug messages for raw target and object targets added
  * launch file for rosbag testing added
  * Launch file for combination of laser scanner and radar added
  * PCL converter ignores missing intensity values
  * point cloud2image filter added, timestamping optimized
  * Device Identiier handling opimized for MRS1xxx and LMS1xxx
  * test files added
  * omitting of laserscan frameid fixed
  * debug messages removed from test script
  * generation of test launch file without starting the test can be controlled by
    using setting flag entry launch_only to true.
  * Switching of radar properties improved
  * Tracking method and output selection for radar
  * Test application for using min/max-interval checking
    and added more test parameter
  * support for rms3xx prepared
  * Copyright added
  * licensed under apache 2.0
  * file based simulation based on file name pattern added and evaluated.
  * patches for ubuntu
  * pointcloud2 prepared
  * Parsing and test driven development optimized
  * Simulation for objects added
  * support of radar simulation
  * Contributors: Dave Niewinski, Michael Lehning, Sai Kishor Kothakota, Unknown, unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Wed, 30 Jan 2019 23:00:00 -0000

ros-noetic-sick-scan (0.0.13-1focal) focal; urgency=high

  * moved some cpp files to ensure Debian compatibility
  * Contributors: Unknown

 -- Michael Lehning <michael.lehning@lehning.de>  Tue, 01 May 2018 22:00:00 -0000

ros-noetic-sick-scan (0.0.12-1focal) focal; urgency=high

  * Added script to start all test sequentially
  * Added RSSi and Range Deviation Test to sick_scan_test
  * channel handling for 8 bit rssi values corrected
  * Defines for param keyword introduced


=== debian/control ===
Source: ros-noetic-sick-scan
Section: misc
Priority: optional
Maintainer: Michael Lehning <michael.lehning@lehning.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-generation, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-visualization-msgs
Homepage: http://wiki.ros.org/sick_scan
Standards-Version: 3.9.2

Package: ros-noetic-sick-scan
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-diagnostic-updater, ros-noetic-dynamic-reconfigure, ros-noetic-message-runtime, ros-noetic-pcl-conversions, ros-noetic-pcl-ros, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-tf, ros-noetic-tf2, ros-noetic-visualization-msgs
Description: A ROS driver for the SICK TiM and SICK MRS series of lidars.
 This package is based on the original sick_tim-repository of Martin Günther et al.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-sick-scan//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
